<?php
/**
 * @package     PHP-Bridge
 * @subpackage  com_phpbridge
 *
 * @copyright   Copyright (C) 2017 Henry Schorradt, Inc. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 */

/**
* PHPBridge Created by Henry Schorradt
*/
namespace Schorradt;
use \JFactory;
use \JText;

defined('_JEXEC') or die('Restricted access');

class PhpBridgePhpModul {

	private	$run='';
	private	$mode='';
	private	$data=array();
	private $scriptfile = '';
		
	public function __construct($run='',$mode='',$data=''){
		$this->run = str_replace(array('..', '/'),'',addslashes(strip_tags($run)));
		$this->mode = addslashes(strip_tags($mode));
		$this->data = array_map('trim', explode(",",strip_tags($data)));
	}
		
	public function init($params){
		
		$path = $params->get('pb_path','templatephp');
		
		$app = JFactory::getApplication();

        switch($path){
            case'rootphp':
                $tempfilename = JPATH_SITE.'/php/'.$this->run.'.php';
                break;
            default:
                $tempfilename = JPATH_SITE.'/templates/'.$app->getTemplate().'/php/'.$this->run.'.php';
                break;
        }

        //SecureCheck
        $checkContent = file_get_contents($tempfilename);
        if(!preg_match('#_JEXEC#imU', $checkContent) && !preg_match('#defined#imU', $checkContent)){
            $app->enqueueMessage(JText::_('COM_PHPBRIDGE_MISSING_SECURITY_CODE'), 'error');
            $tempfilename = '';
        }
		
		if(is_file($tempfilename)){
			$this->scriptfile = $tempfilename;
		}else{
			$this->scriptfile = JPATH_SITE.'/components/com_phpbridge/library/emptyscript.php';
		}
	}

	public function runScript(){
		$mode = $this->mode;
		$data = $this->data;
        $run = $this->run;
		$filename = addslashes(strip_tags($this->scriptfile));

		ob_start();
		if(is_file($filename))
		    try {
                include $filename;
            }catch(\Exception $e){

            }
		unset($filename);
		return ob_get_clean();
	}

}